#! /usr/local/bin/ruby
require "rexml/document"
require 'rexml/streamlistener'
include REXML

TARGET_MAIN     = "target=\"main\""
TARGET_SRC      = "target=\"src\""

WORKING_DIR     = "./HTML/rxref.files/"
DEFAULT_DIR     = "./HTML/"

RXREF_MAIN       = "rxref_main.html"
RXREF_INDEX      = "rxref_index.html"
RXREF_MACINFO    = "rxref_macinfo.html"
RXREF_MACROS1    = "mrxref_macros1.html"
RXREF_MACROS2    = "mrxref_macros2.html"
RXREF_MACROS3    = "mrxref_macros3.html"

ST1  = 0  ; ST2  = 1
UN1  = 2  ; UN2  = 3
TY1  = 4  ; TY2  = 5
ENT1 = 6  ; ENT2 = 7
ENC1 = 8  ; ENC2 = 9
LA1  = 10 ; LA2  = 11
FU1  = 12 ; FU2  = 13
VA1  = 14 ; VA2  = 15
FI1  = 16 ; FI2  = 17

class Handler
  include StreamListener

  @@e = Array.new
  @@stack = Array.new
  @@flag = Array.new
  @@type = Array.new
  @@abst_flag = 0
  @@nest = 0
  @@info = 0
  @@section = 0
  @@inlined = 0
  @@get = nil
  @@directory = Array.new
  @@dir = 0
  @@dirs = 0
  @@files = 0
  @@start_file = 0
  @@define = Array.new
  @@undef = Array.new
  @@defines = Array.new
  @@undefs = Array.new
  @@include = Array.new
  @@sp = 0	 
  @@get_flag = nil
  @@offset = 0
  @@macro = 0
  @@end_num = 0

  def tag_start(name, attrs)
    if name=="section" 
      @@section += 1
    else
      case @@section
      when 1 #add_rev
	if attrs[1][1] == "DW_TAG_subrange_type"
	  @@get = attrs[0][1]
	elsif @@get != nil
	  if attrs[0][1] == "DW_AT_upper_bound"
	    $array_bounds[@@get] = attrs[1][1]
	    @@get = nil
	  end
	end
      when 2 #debug_info 
        if name == "tag"
	  if @@abst_flag != 0
	    @@abst_flag += 1
	  elsif (a=attrs[0][1]) == "DW_TAG_inlined_subroutine" 
	    @@inlined = 1
	  else
	    case a
	    when  "DW_TAG_base_type","DW_TAG_array_type","DW_TAG_pointer_type","DW_TAG_subroutine_type","DW_TAG_volatile_type","DW_TAG_const_type"
	      @@flag[@@nest] = 1
	      /\d+/ =~ attrs[2][1]
	      @@type[@@nest] = $&
	    when "DW_TAG_structure_type","DW_TAG_union_type","DW_TAG_typedef","DW_TAG_enumeration_type"
	      @@flag[@@nest] = 2
	      /\d+/ =~ attrs[2][1]
	      @@type[@@nest] = $&
	    else
	      @@flag[@@nest] = 3
	    end
	    @@e[@@nest] = Array.new
	    @@e[@@nest][0] = Hash.new
	    @@e[@@nest][0]["0"] = Array.new(2)
	    @@e[@@nest][0]["0"][0] = a
	  if a == "DW_TAG_subrange_type"
	    @@e[@@nest][0]["0"][1] = attrs[3][1]
	  else
	    @@e[@@nest][0]["0"][1] = attrs[2][1]
	  end
	    @@stack[@@nest] = 1
	    @@nest += 1
	  end
	elsif name == "attribute" 
	  if @@inlined != 1
	    if @@abst_flag == 0
	      if (a=attrs[0][1])=="DW_AT_location" || a=="DW_AT_data_member_location" || a=="DW_AT_inline"
		@@get_flag = a
	      elsif a == "DW_AT_abstract_origin"
		@@abst_flag = 1
	      else
		@@e[@@nest-1][0][attrs[0][1]] = attrs[1][1]
	      end
	    end
	  end
	end 
      when 3 #debug_line
        if name=="directory"
	  @@dirs += 1
	elsif name=="file"
	  @@files += 1
	  @@dir = attrs[1][1].to_i
	elsif name=="offset"
	  $all_files[@@offset] = Array.new
	  @@directory[@@offset] = Array.new
	  @@directory[@@offset][0] = "."
	  @@offset += 1
	end
      when 4 #macro_info
        case name
	when "start_file"
	  @@include[@@start_file] = Array.new
	  @@include[@@start_file][1] = attrs[0][1]
	  @@include[@@start_file][2] = attrs[1][1]
	  @@defines[@@start_file] = Array.new 
	  @@undefs[@@start_file] = Array.new
	  if @@start_file == 0
	    @@include[0][0] = "1"
	  else
	    @@include[@@start_file][0] = @@include[@@sp][2]
	    @@sp += 1
	  end
	  @@define[@@sp] = 0
	  @@undef[@@sp] = 0
	  @@start_file += 1
	when "define_normal","define_func"
	  @@defines[@@sp][@@define[@@sp]] = Array.new(4)
	  @@defines[@@sp][@@define[@@sp]][0] = attrs[0][1]
	  @@defines[@@sp][@@define[@@sp]][1] = attrs[1][1]
	  @@defines[@@sp][@@define[@@sp]][2] = attrs[2][1]
	  @@defines[@@sp][@@define[@@sp]][3] = attrs[3][1]
	  @@define[@@sp] += 1
	when "undef"
	  @@undefs[@@sp][@@undef[@@sp]] = Array.new(2)  
	  @@undefs[@@sp][@@undef[@@sp]][0] = attrs[0][1]
	  @@undefs[@@sp][@@undef[@@sp]][1] = attrs[1][1]
	  @@undef[@@sp] += 1
	when "end_file"
	  
          @@sp -= 1
          if @@sp == 0
	    @@defines[0][@@define[0]] = Array.new(1)
	    @@defines[0][@@define[0]][0] = "end"
	    @@undefs[0][@@undef[0]] = Array.new(1)
	    @@undefs[0][@@undef[0]][0] = "end"
	    @@define[0] += 1
	    @@undef[0] += 1
	    @@end_num += 1
	  elsif @@sp == -1
	    $includes[@@macro] = @@include
	    $defines[@@macro] = @@defines
	    $undefs[@@macro] = @@undefs
	    @@include = Array.new
	    @@define = Array.new
	    @@undef = Array.new
	    $end_num[@@macro] = @@end_num
	    @@end_num = 0
	    @@start_file = 0
	    @@sp = 0
	  end
	end
      end
    end
  end

  def text(text)
    if text[0] != 10
      if @@dirs != 0
	@@directory[@@offset-1][@@dirs] = text
      elsif @@files != 0
	if $files[1]==nil
	  $files[1]=text
	  $paths[1]=@@directory[@@offset-1][@@dir]+"/"
	  $all_files[@@offset-1][@@files] = 1
	else
	  @@info = 0
	  for i in 1..((x=$files.length)-1)
	    if $files[i] == text
	      @@info = i
	      break;
	    end
	  end
	  if @@info == 0
	    $files[x]=text
	    $paths[x]=@@directory[@@offset-1][@@dir]+"/"
	    $all_files[@@offset-1][@@files] = x
	  else
	    $all_files[@@offset-1][@@files] = @@info
	  end
	end
      elsif @@get_flag != nil
	@@e[@@nest-1][0][@@get_flag] = text
	@@get_flag = nil
      end
    end
  end

  def tag_end(name)
    if @@section==2 #debug_info
      if name == "tag"
	if @@nest==1
	  $debug_info[@@info] = @@e[0]
	  @@info += 1
	  @@nest = 0
	else
	  if @@inlined == 1
	    @@inlined = 0
	  elsif @@abst_flag > 0
	    @@abst_flag -= 1
	    if @@abst_flag == 0
	      @@nest -= 1
	      @@e[@@nest] = nil
	    end
	  else
	    case @@flag[@@nest-1]
	    when 1
	      @@nest -= 1
	      $types[@@type[@@nest]] = @@e[@@nest]
	    when 2
	      @@nest -= 1
	      $types[@@type[@@nest]] = @@e[@@nest]
	      @@e[@@nest-1][@@stack[@@nest-1]] = @@e[@@nest]
	      @@stack[@@nest-1] += 1
	    else 
	      @@nest -= 1	
	      @@e[@@nest-1][@@stack[@@nest-1]] = @@e[@@nest]
	      @@stack[@@nest-1] += 1
	    end
	  end
	end
      end
    elsif @@section==3 
      if name=="include_directories"
	@@dirs = 0
      elsif name=="file_names"
	@@files = 0
      end
    end
  end
end

def init()
# take arguments
   option = ""
   while /^\-/ =~ (input = ARGV.shift) 
     option << input
   end 
  #input = ARGV.shift
  $gflag = 0
  if /g/ =~ option
    # remake the DEFEULT_DIR(./HTML) directory
    `rm -rf #{DEFAULT_DIR}; gtags ; htags -nas; mkdir #{WORKING_DIR}`
    $gflag = 1
    i = 1
    $source_files = Array.new
    # find the target source files in htags's htmls
    `ls #{DEFAULT_DIR}S`.each do |e|
      File.open(DEFAULT_DIR+"S/"+e.chomp,"r").each do |line|
	if />.+\.c/ =~ line
	  tmp = $&
	  $source_files[i] = tmp[1, tmp.length];
	  i += 1
	  break
	end
      end
    end
    $num_sources = i
    $sources = Array.new
  else
    `rm -rf #{DEFAULT_DIR} ; mkdir -p HTML/rxref.files`
  end
  $indent_depth = 0
  $ccu = 0 #current compile unit
  $counter4macid = 0
 
  # used for variables scope
  # $current_block = ""
  $types = Hash.new
  $array_bounds = Hash.new
  $includes = Array.new
  $undefs = Array.new
  $defines = Array.new
  $end_num = Array.new
  $debug_info = Array.new
  $all_files = Array.new
  $files = Array.new 
  $paths = Array.new
  $paths2 = Array.new
  #open a xml file and parse it
  if /\.gz/ =~ input then
    Document.parse_stream(`gunzip -c #{input}`, Handler.new)
  else
    Document.parse_stream(File.new(input), Handler.new)
  end
  #used for GNU GLOBAL
  $num_files = $files.length - 1
  if $gflag == 1
    $globals = Array.new($num_files)
    $to_main_path = Array.new($num_files)
    $all_sources = Array.new()
    source2html_g()
  else
    source2html()
  end
# open files to output each cotegories
  $rxref_files = Array.new(18)
  $rxref_files[0] = File.open("./HTML/rxref.files/rxref_structs1.html","w")
  $rxref_files[1] = File.open("./HTML/rxref.files/rxref_structs2.html","w")
  $rxref_files[2] = File.open("./HTML/rxref.files/rxref_unions1.html","w")
  $rxref_files[3] = File.open("./HTML/rxref.files/rxref_unions2.html","w")
  $rxref_files[4] = File.open("./HTML/rxref.files/rxref_typedefs1.html","w")
  $rxref_files[5] = File.open("./HTML/rxref.files/rxref_typedefs2.html","w")
  $rxref_files[6] = File.open("./HTML/rxref.files/rxref_enum_tags1.html","w")
  $rxref_files[7] = File.open("./HTML/rxref.files/rxref_enum_tags2.html","w")
  $rxref_files[8] = File.open("./HTML/rxref.files/rxref_enum_consts1.html","w")
  $rxref_files[9] = File.open("./HTML/rxref.files/rxref_enum_consts2.html","w")
  $rxref_files[10] = File.open("./HTML/rxref.files/rxref_labels1.html","w")
  $rxref_files[11] = File.open("./HTML/rxref.files/rxref_labels2.html","w")
  $rxref_files[12] = File.open("./HTML/rxref.files/rxref_functions1.html","w")
  $rxref_files[13] = File.open("./HTML/rxref.files/rxref_functions2.html","w")
  $rxref_files[14]  = File.open("./HTML/rxref.files/rxref_variables1.html","w")
  $rxref_files[15]  = File.open("./HTML/rxref.files/rxref_variables2.html","w")
  $rxref_files[16]  = File.open("./HTML/rxref.files/rxref_files1.html","w")
  $rxref_files[17]  = File.open("./HTML/rxref.files/rxref_files2.html","w")
end

def source2html_g()
  n = 0
  x = 0
  for i in 1..$num_files
    filename = $files[i]
    j = 1
    $source_files.each do |e|
      break if filename == e
      j += 1
    end
    if j <= $num_sources
      $paths[i] = "./S/"+(j-1).to_s
      $to_main_path[i] = "../"
      $sources[n] = i
      $all_sources[x] = i
      $globals[i] = Array.new
      n += 1
      x += 1
      next
    end
    tmp = ""
    pathname = $paths[i]
    `mkdir -p #{DEFAULT_DIR+pathname}`
    filename.split(/\//).each do |e|
      tmp << e + "/" if !(/\./ =~ e)
    end
    pf = pathname+filename
    `mkdir -p #{DEFAULT_DIR+pathname+tmp}` if tmp != ""
    if /^\./ =~ pathname
      $paths[i] = pf
    else
      $paths[i] = "."+pf 
    end
    $paths2[i] = pf
    if File.exist?(pf)
      $globals[i] = Array.new()
      $all_sources[x] = i
      x += 1
      tmp = ""
      ll = 0
      $paths[i].split(/\//).reverse_each do |a|
	if ll == 0
	  ll += 1
	elsif a == ".."
	  tmp << "HTML/"
	elsif !(/^\./ =~ a)
	  tmp << "../"
	end
      end
      $to_main_path[i] = tmp
    else
     text = File.open(DEFAULT_DIR+pathname+"#{filename}.html", "w")
     text << "<html><body><h1>#{filename}</h1><a name='top'/><hr/><pre>\n#{filename} is not found. </pre><hr/></body></html>\n"
     text.close
    end
  end
end

def source2html()
  for i in 1 .. $num_files
    filename = $files[i]
    pathname = $paths[i]
    `mkdir -p #{DEFAULT_DIR+pathname}`
    tmp = ""
    filename.split(/\//).each do |e|
      tmp << e + "/" if !(/\./ =~ e)
    end
    pf = pathname+filename
    `mkdir -p #{DEFAULT_DIR+pathname+tmp}` if tmp != ""
    if /^\./ =~ pathname
      $paths[i] = pf
    else
      $paths[i] = "."+pf 
    end
    text = File.open(DEFAULT_DIR+pathname+"#{filename}.html", "w")
    text << "<html><body><h1>#{filename}</h1><a name='top'/><hr/><pre>\n"
    begin
      file = File.open(pathname+filename,"r")
      n = 1
      file.each do |line|
	text << "<a name=#{n}><font color='blue'>    #{n}</font> "
        text << line
	n += 1
      end
    rescue
      text << "#{filename} is not found"
    end 
    text << "</pre><hr/></body></html>\n"
    text.close
  end
end

def isSource?(n)
  $all_sources.each do |e|
    return TRUE if n == e
  end
  return FALSE
end

def isGlobal?(n)
  $sources.each do |e|
    return TRUE if n == e
  end
  return FALSE
end

#def get_type(id)
#  type_to_string($types[id])
#end

def base_type_to_string(e)
  e["DW_AT_name"] + " %s"
end

def array_type_to_string(e)
  ###get subscript
  if (tmp = $array_bounds[e[1][0]["0"][1]]) == nil
     result = "" # array[]
  elsif /DW_FORM_data/ =~ tmp 
    if (t=e[1][0]["DW_AT_upper_bound"]) == nil
      result = ""
    else
      result = t.succ
    end
  elsif /DW_FORM_ref/ =~ tmp 
    result = "<em>exp</em>"
  else
    result = "hoge:#{tmp}"
  end
  ###
  sprintf(get_type(e[0]["DW_AT_type"]),"%s[" + result + "]")
end

def ptr_type_to_string(e)
  if (tmp = e["DW_AT_type"]) == nil
    "void (*%s)"
  else
    sprintf(get_type(tmp)," (*%s)")
  end
end

def get_params(e)
  i = 0
  text = ""
  for n in 1..(e.length-1)
    f = e[n][0]
    if (a=f["0"][0]) == "DW_TAG_unspecified_parameters"
      text << ", ..." if i != 0
    elsif a == "DW_TAG_formal_parameter"
      if (tmp=f["DW_AT_type"]) == nil
	type = "void %s"
      else
	type = get_type(tmp)
      end
      text << ", " if i != 0
      if (tmp=f["DW_AT_name"]) == nil
	text << sprintf(type, "")
      else
	text << sprintf(type, tmp)
      end
      i += 1
    end
  end
  i == 0 ? "void" : text
end

def func_type_to_string(e)
  if (tmp = e[0]["DW_AT_type"]) != nil
    sprintf("(%s)(%s)",get_type(tmp), get_params(e))
  else
 #    sprintf("(%s)(%s)","void %s", get_params(e))
    sprintf("void (%%s)(%s)", get_params(e))
  end
end

def volatile_to_string(e)
  if (tmp = e["DW_AT_type"]) == nil
    "void volatile %s" 
  else
    sprintf(get_type(tmp), "volatile %s")
  end
end

def const_to_string(e)
  if (tmp = e["DW_AT_type"]) == nil
    "void const %s" 
  else
    sprintf(get_type(tmp), "const %s")
  end
end

def struct_to_string(e)
  if (name=e[0]["DW_AT_name"]) == nil
    result = "struct { "
    for i in 1..(e.length-1)
      f = e[i][0]
      /\d+/ =~ f["0"][1]
      id = $&
      name = f["DW_AT_name"]
      filename = $paths[$all_files[$ccu][f["DW_AT_decl_file"].to_i]]
      line = f["DW_AT_decl_line"]
      result << sprintf(get_type(f["DW_AT_type"]), " %s")
      result = sprintf(result,"<a href=\"#{filename}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>") + "; "
    end
    result + "} %s" #return
  else
    /\d+/ =~ e[0]["0"][1]
    id = $&
    "struct <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a> %s" 
  end
end

def union_to_string(e)
  if (name=e[0]["DW_AT_name"]) == nil
    result = "union { "
    for i in 1..(e.length-1)
      f = e[i][0]
      /\d+/ =~ f["0"][1]
      id = $&
      name = f["DW_AT_name"]
      filename = $paths[$all_files[$ccu][f["DW_AT_decl_file"].to_i]]
      line = f["DW_AT_decl_line"]
      result << sprintf(get_type(f["DW_AT_type"]), " %s")
      result = sprintf(result,"<a href=\"#{filename}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>") + "; "
    end
    result + "} %s" #return
  else
    /\d+/ =~ e[0]["0"][1]
    id = $&
    "struct <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a> %s" 
  end
end

def typedef_to_string(e)
  /\d+/ =~ e["0"][1]
  id = $&
  name = e["DW_AT_name"]
  "<a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a> %s"
end

def enum_to_string(e)
  if (tmp = e[0]["DW_AT_name"]) ==nil
    result = "{ "
    for i in 1..(e.length-1)
      f = e[i][0]
      /\d+/ =~ f["DW_TAG_enumerator"]
      id = $&
      name = f["DW_AT_name"]
      value = f["DW_AT_const_value"]
      result << "<a href=\"\##{id}\""+TARGET_MAIN+">#{name}</a> = #{value}, "
    end
    result + "} %s"
  else
    /\d+/ =~ e[0]["0"][1]
    id = $&
    name = e[0]["DW_AT_name"]
    "enum <a href=\"\##{id}\""+TARGET_MAIN+">#{name}</a> %s"
  end
end 

def get_type(id)
  e = $types[id]
  case e[0]["0"][0]
  when "DW_TAG_base_type"
    base_type_to_string(e[0])
  when "DW_TAG_array_type"
    array_type_to_string(e)
  when "DW_TAG_pointer_type"
    ptr_type_to_string(e[0])
  when "DW_TAG_subroutine_type"
    func_type_to_string(e)
  when "DW_TAG_volatile_type"
    volatile_to_string(e[0])
  when "DW_TAG_const_type"
    const_to_string(e[0])
  when "DW_TAG_structure_type"
    struct_to_string(e)
  when "DW_TAG_union_type"
    union_to_string(e)
  when "DW_TAG_typedef"
    typedef_to_string(e[0])
  when "DW_TAG_enumeration_type"
    enum_to_string(e)
  else
    e[0]["0"][0]
  end
end

def output_compile_unit(e, text)
  /\d+/ =~ e[0]["0"][1]
  id = $&
  filename = e[0]["DW_AT_name"]
  comp_dir = e[0]["DW_AT_comp_dir"]
  high_pc = format("%x", e[0]["DW_AT_high_pc"])
  low_pc = format("%x", e[0]["DW_AT_low_pc"])
  producer = e[0]["DW_AT_producer"]
  for i in 1..$num_files do
    if filename == $files[i]
      pathname = $paths[i]
      break
    end
  end
  text << "<h1><a href=\"#{pathname}.html\""+TARGET_SRC+">#{filename}</a> --- #{comp_dir}, 0x#{low_pc}-0x#{high_pc}, #{producer}</h1>\n<a name=\"#{id}\"><hr/><pre>\n"
###output_all_files
  $rxref_files[FI1] << "#{filename} @ <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{filename}</a>; <font color=\"red\">/* <a href=\"#{pathname}.html\""+TARGET_SRC+">#{filename}</a> */</font>\n"
###
  for i in 1..(e.length-1)
    output_debug_info(e[i],text)
  end
  text << "</pre><hr/>\n"
end

def output_subprogram(e, text)
  external = 0
  if (tmp=e[0]["DW_AT_external"]) != nil
    if tmp != "1"
      text << "static "
      external = 1
    end
  else
    text << "static "
    external = 1
  end
  name = e[0]["DW_AT_name"]
  tmp = e[0]["DW_AT_decl_file"].to_i
  filename = $files[tmp]
  pathname = $paths[tmp]
  line = e[0]["DW_AT_decl_line"]
  if (hoge=e[0]["DW_AT_type"]) == nil
    ret_type = "void %s"
  else
    ret_type = get_type(hoge)
  end
  low_pc = format("%x",e[0]["DW_AT_low_pc"].to_i)
  high_pc = format("%x",e[0]["DW_AT_high_pc"].to_i)
  inlined = ""  if (inlined=e[0]["DW_AT_inline"]) == nil
  extern = 0
  if (t=e[0]["DW_AT_declaration"])!=nil && t!="0"
    extern = 1
    text << "extern "
  end
  /\d+/ =~ e[0]["0"][1]
  id = $&
  param = get_params(e)
  text <<  "  <font color=\"red\">/* 0x#{low_pc}-0x#{high_pc}, <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line}</a> #{inlined}*/</font>\n" +
    sprintf(ret_type, "<a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>") + " ("+param+")\n{\n"
  if $gflag == 1
    ###for global
    if isSource?(tmp) 
      $globals[tmp][line.to_i] = "  <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>"
    end
    ###
  end
  ###output_all_functions
  text1 = $rxref_files[FU1]
  text2 = $rxref_files[FU2]
  hoge = sprintf(ret_type, "%s(#{param})")
  hoge = sprintf(hoge, "<a href=\"#{RXREF_MAIN}\##{id}\"#{TARGET_MAIN}>#{name}</a>")
  text1 << name + " @ "
  text2 << filename+" "+pathname+" @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>"
  if (external == 1)
    text1 <<  "static "
    text2 <<  "static "
  end
  if (extern == 1)
    text1 << "extern "
    text2 << "extern "
  end
  text1 << hoge+"; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
  text2 << hoge+";\n"
  ###
  $indent_depth += 1
 #  $current_block = "<a href=\"#{pathname}.html\##{line}\""+TARGET_MAIN+">#{name}</a>"
  for i in 1..(e.length-1)
    output_debug_info(e[i],text)
  end
#  $current_block = "global"
  $indent_depth -= 1
    text << "}\n"
end
  
def output_lexical_block(e, text)
  /\d+/ =~ e[0]["0"][1]
  id = $&
  low_pc = format("%x",e[0]["DW_AT_low_pc"].to_i)
  high_pc = format("%x",e[0]["DW_AT_high_pc"].to_i)

  text << sprintf("%*s", $indent_depth*4, "") + "{ <a name=\"#{id}\"/><font color=\"red\">/* 0x#{low_pc}-0x#{high_pc} */</font>\n"
  $indent_depth += 1;
  for i in 1..(e.length-1)
    output_debug_info(e[i],text)
  end
  $indent_depth -= 1;
  text << sprintf("%*s", $indent_depth*4, "") + "}\n"
end

def output_variable(e,text)
  /\d+/ =~ e["0"][1]
  id = $&
  name = e["DW_AT_name"]
  tmp = $all_files[$ccu][e["DW_AT_decl_file"].to_i]
  filename = $files[tmp]
  pathname = $paths[tmp]
  line = e["DW_AT_decl_line"]
  type = get_type(e["DW_AT_type"])
  text << sprintf("%*s", $indent_depth*4, "")
  external = 0
  if e["DW_AT_externale"] == "0"
    text << "static "
    external = 1
  end
  extern = 0
  if (t=e["DW_AT_declaration"])!=nil && t!="0"
    text << "extern "
    extern = 1
  end
  if (hoge=e["DW_AT_location"]) == nil
    location = "??"
  elsif /DW_OP_fbreg/ =~ hoge
    n = hoge[13..(hoge.length-1)].to_i
    location = "%fp+(#{n})"
  elsif /DW_OP_addr/ =~ hoge
    n = format("%x",hoge[12..(hoge.length-1)].to_i)
    location = "0x#{n}"
  elsif /DW_OP_reg/ =~ hoge
    n = hoge[11..(hoge.length-1)].to_i
    location = "%r#{n}"
  else
    location = "ELSE in output_variables"
  end
  text << sprintf(type, "<a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>") +
    "; <font color=\"red\">/* #{location}, <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line}</a> */</font>\n"
  if $gflag == 1
    ###for global
    if isSource?(tmp)
      if $globals[tmp][line.to_i] == nil
	$globals[tmp][line.to_i] = " <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>"
      else
	$globals[tmp][line.to_i] << " <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
      end
    end
    ### 
  end
###output_all_variables
  text1 = $rxref_files[VA1]
  text2 = $rxref_files[VA2]
  hoge = sprintf(type, "<a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>")
  text1 << "#{name} @ "
  text2 << filename+" "+pathname+" @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a></font> */</font>"
  if external == 1
    text1 << "static "
    text2 << "static "
  end
  if extern == 1
    text1 << "extern "
    text2 << "extern "
  end
  text1 << hoge+"; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
  text2 << hoge+";\n"
###
end

def output_label(e,text)
  /\d+/ =~ e["0"][1]
  id = $&
  name = e["DW_AT_name"]
  tmp = $all_files[$ccu][e["DW_AT_decl_file"].to_i]
  filename = $files[tmp]
  pathname = $paths[tmp]
  line = e["DW_AT_decl_line"].to_i
  low_pc = format("%x", e["DW_AT_low_pc"].to_i)
  
  text << sprintf("%*s", $indent_depth*4, "") +
    "<a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>" +
    "<font color=\"red\">/* 0x#{low_pc}, <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line}</a>*/</font>\n"
  if $gflag == 1
    ###for global
    if isSource?(tmp)
      $globals[tmp][line.to_i] = "  <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
    end
    ### 
  end
###output_all_labels
  $rxref_files[LA1] << name+" @ label <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
  $rxref_files[LA2] << "#{filename} #{line} @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font> label <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>;\n"
###
end

def output_typedef(e,text)
  /\d+/ =~ e["0"][1]
  id = $&
  name = e["DW_AT_name"]
  tmp = $all_files[$ccu][e["DW_AT_decl_file"].to_i]
  filename = $files[tmp]
  pathname = $paths[tmp]
  line = e["DW_AT_decl_line"]
  type = get_type(e["DW_AT_type"])
  text << sprintf("%*s", $indent_depth*4, "") +
    "typedef "+ sprintf(type, "<a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>") +
    " <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line}</a> */</font>\n"
  if $gflag == 1
    ###for global
    if isSource?(tmp) 
      $globals[tmp][line.to_i] = "  <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">typedef:#{name}</a>&gt;</font>"    end
    ###
  end 
###output_all_typedefs
  $rxref_files[TY1] << name+" @ typedef <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
  $rxref_files[TY2] << filename+" "+line+" @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font> union <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>;\n"
###
end

def output_struct(e,text)
  /\d+/ =~ e[0]["0"][1]
  id = $&
  if (name = e[0]["DW_AT_name"]) == nil
    name = "??"
  end
  if (tmp = e[0]["DW_AT_decl_file"]) == nil
    filename = "??"
  else
    tmp = $all_files[$ccu][tmp.to_i]
    filename = $files[tmp]
    pathname = $paths[tmp]
  end
  if (line = e[0]["DW_AT_decl_line"]) == nil
    line = "??"
  end
  text << sprintf("%*s", $indent_depth*4, "") +
    "struct <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>" +
    " <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line} </a>*/</font>\n"
  output_members(e, text)
  text << ";\n"
  if $gflag == 1
    ###for global
    if tmp!=nil && isSource?(tmp)
      $globals[tmp][line.to_i] = "  <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
    end
    ### 
  end
###output_all_structs
  if name != "??"
    $rxref_files[ST1] << name+" @ struct <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
    if filename != "??"
      $rxref_files[ST2] << filename+" "+line+" @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font> struct <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>;\n"
    end
  end
###
end

def output_union(e,text)
  /\d+/ =~ e[0]["0"][1]
  id = $&
  if (name = e[0]["DW_AT_name"]) == nil
    name = "??"
  end
  if (tmp = e[0]["DW_AT_decl_file"]) == nil
    filename = "??"
  else
    tmp = $all_files[$ccu][tmp.to_i]
    filename = $files[tmp]
    pathname = $paths[tmp]
  end
  if (line = e[0]["DW_AT_decl_line"]) == nil
    line = "??"
  end
  text << sprintf("%*s", $indent_depth*4, "") +
    "union <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>" +
    " <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line}</a> */</font>\n"
  output_members(e, text)
  text << ";\n"
  if $gflag == 1
    ###for global
    if isSource?(tmp)
      $globals[tmp][line.to_i] = "  <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
    end
    ### 
  end
###output_all_unions
  if name != "??"
    text1 = $rxref_files[UN1] << name+" @ union <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
    if filename != "??"
    text2 = $rxref_files[UN2]  << filename+" "+line+" @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font> union <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>;\n"
    end
  end
###
end

def output_members(e,text)
  text << sprintf("%*s", $indent_depth*4, "") + "{\n"
  $indent_depth += 1
  for i in 1..(e.length-1)
    f = e[i][0]
    /\d+/ =~ f["0"][1]
    id = $&
    name = f["DW_AT_name"]
    tmp = $all_files[$ccu][f["DW_AT_decl_file"].to_i]
    filename = $files[tmp]
    pathname = $paths[tmp]
    line = f["DW_AT_decl_line"].to_i
    type = get_type(f["DW_AT_type"]);
    
    text << sprintf("%*s", $indent_depth*4, "") +
      sprintf(type, "<a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>")
    if (tmp=f["DW_AT_data_member_location"]) == nil
      text << " <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line} </a>*/</font>"
    elsif /DW_OP_plus_uconst/ =~ tmp
      /\d+/ =~ tmp
      offset = $&
      text << " <font color=\"red\">/* #{offset}, <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+"> #{filename}:#{line} </a>*/</font>"
    else
      puts tmp
      exit(-1)
    end
    text << "\n"
  end
  $indent_depth -= 1
  text << sprintf("%*s", $indent_depth*4, "") + "}"
end

def output_enum(e, text)
  /\d+/ =~ e[0]["0"][1]
  id = $&
  tmp = $all_files[$ccu][e[0]["DW_AT_decl_file"].to_i]
  filename = $files[tmp]
  pathname = $paths[tmp]
  line = e[0]["DW_AT_decl_line"]
  if (name = e[0]["DW_AT_name"]) == nil
    name = "??"
  else
    if $gflag == 1
      ###for global
      if isSource?(tmp)
	$globals[tmp][line.to_i] = "  <font color=\"red\">&lt;<a href=\""+$to_main_path[tmp]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
      end
      ### 
    end
  
###output_all_enum_tags
    $rxref_files[ENT1] << "#{name} @ enum <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
    $rxref_files[ENT2] << "#{filename} #{line} @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font> enum <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>;\n"
###
  end
  text << sprintf("%*s", $indent_depth*4, "") +
    "enum <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{name}</a><a name=\"#{id}\"/>" +
    " <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line} </a>*/</font>\n"
  output_enum_constants(e,text,tmp,line)
  text << ";\n"
end

def output_enum_constants(e,text,n,line)  
  text << sprintf("%*s", $indent_depth*4, "") + " {\n"
  $indent_depth += 1

  tmp = line.to_i
  for i in 1..(e.length-1)
    f = e[i][0]
    /\d+/ =~ f["0"][1]
    id = $&
    name = f["DW_AT_name"]
    value = f["DW_AT_const_value"]

    text << sprintf("%*s", $indent_depth*4, "") +
      "#{name} = #{value},<a name=\"#{id}\"/>\n"
   if $gflag == 1
  ###for global
    if isSource?(n)
      if $globals[n][tmp] == nil
	$globals[n][tmp] = " <font color=\"red\">&lt;<a href=\""+$to_main_path[n]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
      else
	$globals[n][tmp] << " <font color=\"red\">&lt;<a href=\""+$to_main_path[n]+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
      end
    end
  ### 
   end
###output_enum_consts
    filename = $files[n]
    pathname = $paths[n]
    $rxref_files[ENC1] << "#{name} @ <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>; <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font>\n"
    $rxref_files[ENC2] << "#{filename} #{line} @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\""+TARGET_SRC+">#{filename}:#{line}</a> */</font> <a href=\""+RXREF_MAIN+"\##{id}\""+TARGET_MAIN+">#{name}</a>;\n"
###
  end
  $indent_depth -= 1
  text << sprintf("%*s", $indent_depth*4, "") + "}"
end

def output_debug_info(e, text)
  case  e[0]["0"][0]
  when "DW_TAG_compile_unit"
    output_compile_unit(e, text)
  when "DW_TAG_subprogram"
    output_subprogram(e, text)
  when "DW_TAG_lexical_block"
     output_lexical_block(e, text)
  when "DW_TAG_variable"
    output_variable(e[0], text)
  when "DW_TAG_label"
    output_label(e[0], text)
  when "DW_TAG_typedef"
    output_typedef(e[0], text)
  when "DW_TAG_structure_type"
    output_struct(e, text)
  when "DW_TAG_union_type"
    output_union(e, text)
  when "DW_TAG_enumeration_type"
    output_enum(e,text)
  else
    e[0]["0"][0]
  end
end

def output_debug_info_top
 
  text = File.open(DEFAULT_DIR + RXREF_MAIN, "w");
  text <<  "<html><body><hr/>\n"
  
  $debug_info.each do |e|
     output_debug_info(e,text)
    $ccu += 1
  end
  text << "<hr/></html></body>\n"
  text.close
end

def output_macroinfo()
  text1 = File.open(WORKING_DIR+RXREF_MACROS1,"w")
  text2 = File.open(WORKING_DIR+RXREF_MACROS2,"w")
  text3 = File.open(WORKING_DIR+RXREF_MACROS3,"w")
  text4 = File.open(WORKING_DIR+RXREF_MACINFO,"w")	
 # stack_size = 1024
#  file_stack = Array.new(stack_size)
  
  for xx in 0..($includes.length-1)
    i = 0
    $includes[xx].each do |e|
      m = $all_files[0][e[2].to_i]
      filename = $files[m]
      pathname = $paths[m]
      if i != 0
	id = "MACINFOID" + $counter4macid.to_s
	$counter4macid += 1
	n = $all_files[0][e[0].to_i]
	filename2 = $files[n]
	pathname2 = $paths[n]
	line = e[1]
	if $gflag == 1
	  ### for global
	  if isSource?(n)
	    if $globals[n][line.to_i] == nil
	      $globals[n][line.to_i] = " <font color=\"red\">&lt;<a href=\""+$to_main_path[n]+pathname+".html\##{id}\""+TARGET_MAIN+">#{filename}</a>&gt;</font>" 
	    else
	      $globals[n][line.to_i] << " <font color=\"red\">&lt;<a href=\""+$to_main_path[n]+pathname+".html\##{id}\""+TARGET_MAIN+">#{filename}</a>&gt;</font>"
	    end
	  end
	  ### 
	end
	text1 << filename+" @ #include <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{filename}</a> <font color=\"red\">/* <a href=\"#{pathname2}.html\##{line}\" "+TARGET_SRC+">#{filename2}:#{line}</a> */</font>\n"
          text2 << "a"+filename+" @ #include <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{filename}</a> <font color=\"red\">/* <a href=\"#{pathname2}.html\##{line}\" "+TARGET_SRC+">#{filename2}:#{line}</a> */</font>\n"
          text3 << filename+" "+line+" @ <font color=\"red\">/* <a href=\"#{pathname2}.html\##{line}\" "+TARGET_SRC+">#{filename2}:#{line}</a> */</font> #include <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{filename}</a>\n"
          text4 << "<a name=\"#{id}\">#include <a href=\"#{pathname2}.html\##{line}\" "+TARGET_SRC+">#{filename}</a> <font color=\"red\">/*  <a href=\"#{pathname2}.html\##{line}\" "+TARGET_SRC+">#{filename2}:#{line}</a> */</font>\n"
      end
      endd = $end_num[xx]
      if $defines[xx][i] != nil
	$defines[xx][i].each do |f| 
	  if f[0] == "end"
	    endd -= 1
	  else
	    id = "MACINFOID" + $counter4macid.to_s
	    $counter4macid += 1
	    name = f[1]
	    body = f[3]
	    signature = f[2]
	    if $gflag == 1
	      if endd != 0 && isGlobal?(m)
		line = "1"
		line2 = "0"
	      elsif isSource?(m)
		line = line2 = f[0]
		###for global
		if $globals[m][line.to_i] == nil
		  $globals[m][line.to_i] = " <font color=\"red\">&lt;<a href=\""+$to_main_path[m]+RXREF_MACINFO+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
		else
		  $globals[m][line.to_i] << " <font color=\"red\">&lt;<a href=\""+$to_main_path[m]+RXREF_MACINFO+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
		end
		###
	      else
		line = line2 = f[0]
	      end
	    else
	      line = line2 = f[0]
	    end
	    text1 << name+" @ #define <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{signature}</a> <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font>\n"
        text2 << "d"+name+" @ #define <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{signature}</a> <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font>\n"
        text3 << filename+" "+line+" @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font> #define <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{signature}</a>\n"
        text4 << "<a name=\"#{id}\">#define <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{signature}</a> #{body} <font color=\"red\">/*  <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font>\n"
	  end
	end
      end
      endd = $end_num[xx]
      if $undefs[xx][i] != nil
	$undefs[xx][i].each do |f| 
	  if f[0] == "end"
	    endd -= 1
	  else
	    id = "MACINFOID" + $counter4macid.to_s
	    $counter4macid += 1
	    name = f[1]
	    if $gflag == 1
	      if endd != 0 && isGlobal?(m)
		line = "1"
		line2 = "0"
	      elsif isSource?(m)
		line = line2 = f[0]
		###for global
		if $globals[m][line.to_i] == nil
		  $globals[m][line.to_i] = " <font color=\"red\">&lt;<a href=\""+$to_main_path[m]+RXREF_MACINFO+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
		else
		  $globals[m][line.to_i] << " <font color=\"red\">&lt;<a href=\""+$to_main_path[m]+RXREF_MACINFO+"\##{id}\""+TARGET_MAIN+">#{name}</a>&gt;</font>" 
		end
		###
	      else
		line = line2 = f[0]
	      end
	    else
	      line = line2 = f[0]
	    end
	    text1 << name+" @ #undef <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{name}</a> <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font>\n"
        text2 << "u"+name+" @ #undef <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{name}</a> <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font>\n"
        text3 << filename+" "+line+" @ <font color=\"red\">/* <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font> #undef <a href=\""+RXREF_MACINFO+"\##{id}\" "+TARGET_MAIN+">#{name}</a>\n"
        text4 << "<a name=\"#{id}\">#undef <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{name}</a> <font color=\"red\">/*  <a href=\"#{pathname}.html\##{line}\" "+TARGET_SRC+">#{filename}:#{line2}</a> */</font>\n"
	  end
	end
	i += 1
      end
    end
  end
  text1.close
  text2.close
  text3.close
  text4.close
end
  
def final
  if $gflag == 1
    $all_sources.each do |e|
      text = File.open("tmp","w")
      if isGlobal?(e)
	n = 2
	hoge = 0
	#puts $paths[e]
	File.open(DEFAULT_DIR+$paths[e]+".html","r").each do |line|
	  if (hoge == 0) 
	    if /NAME=1/ =~ line
	      hoge = 1
	      if $globals[e][1] != nil
		text << line.chomp + $globals[e][1]+"\n"
	      else
		text << line
	      end
	    else
	      text << line
	    end
	  else
	    if $globals[e][n] != nil
	      text << line.chomp + $globals[e][n]+"\n"
	    else
	      text << line
	    end
	    n += 1
	  end
	end
      else
	n = 0
	File.open($paths2[e],"r").each do |line|
	  if n == 0
	    text << "<html><body><h1>#{$files[e]}</h1><a name='top'/><hr/><pre>\n"
        n = 1
	  end
	  if $globals[e][n] != nil
	    text << "<a name=#{n}><font color='blue'>    #{n}</font> " + line.chomp + $globals[e][n]+"\n"
	  else
	    text << "<a name=#{n}><font color='blue'>    #{n}</font> " + line
	  end
	  n += 1
	end
	text << "</pre><hr/></body></html>\n"
      end
      text.close
      `mv tmp #{DEFAULT_DIR+$paths[e]}.html`
    end
  end
  for i in ST1..FI2
    $rxref_files[i].close
  end
  `rxref.csh`
end
t = Time.now
init()
s = Time.now
print "init:",s-t,"\n"
output_debug_info_top()
v = Time.now
print "output debug info:",v-s,"\n"
output_macroinfo()
u = Time.now
print "output macro info:",u-v,"\n"
final()
w = Time.now
print "final:",w-u,"\n"
print "END:",w-t,"\n"




